## ats-lang-anairiats 0.2.4

=== Makefile ===
#########################################################################
##                                                                     ##
##                         Applied Type System                         ##
##                                                                     ##
##                              Hongwei Xi                             ##
##                                                                     ##
#########################################################################

##
## ATS/Anairiats - Unleashing the Potential of Types!
##
## Copyright (C) 2002-2008 Hongwei Xi.
##
## ATS is  free software;  you can redistribute it and/or modify it under
## the  terms of the  GNU General Public License as published by the Free
## Software Foundation; either version 2.1, or (at your option) any later
## version.
##
## ATS is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without  even  the  implied  warranty  of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
## for more details.
##
## You  should  have  received  a  copy of the GNU General Public License
## along  with  ATS;  see  the  file  COPYING.  If not, write to the Free
## Software Foundation, 51  Franklin  Street,  Fifth  Floor,  Boston,  MA
## 02110-1301, USA.
##

######

##
## Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
## Author: Likai Liu (liulk AT cs DOT bu DOT edu)
## Author: Yuri D'Elia (wavexx AT thregr DOT org)
##

.SUFFIXES:
all:: Makefile

######

# integration with autoconf.

SRC_CONFIG_FILES := config.mk.in config.h.in
BUILT_CONFIG_FILES := $(SRC_CONFIG_FILES:%.in=%)

Makefile: config.mk

config.status: configure
	./configure
	touch $@

$(BUILT_CONFIG_FILES): %: config.status $(filter-out %,$(SRC_CONFIG_FILES))
	./config.status
	touch $(BUILT_CONFIG_FILES)

config.h.in: configure.ac
	autoheader $<
	touch $@

configure: configure.ac $(SRC_CONFIG_FILES)
	aclocal
	automake --add-missing --foreign || true
	autoconf
	touch $(BUILT_CONFIG_FILES)

-include config.mk

######

DESTDIR :=

export ATSHOME
export ATSHOMERELOC
export ATSHOMEQ

######

install:: config.h
	# recursively install all files in the list except .svn control files.
	for d in ccomp/runtime contrib doc libats libc prelude; do \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -d $(DESTDIR)$(ATSNEWHOME)/"$$d" && \
	  find "$$d" -name .svn -prune -o -type f \
            -exec $(INSTALL) -m 644 -D \{} $(DESTDIR)$(ATSNEWHOME)/\{} \; \
	    -print; \
	done

	# install specific files in the list as regular files.
	for f in \
	    COPYING INSTALL *.txt ccomp/lib/*.a ccomp/lib64/*.a config.h; \
	do \
	  [ -f "$$f" ] || continue; \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 644 -D "$$f" $(DESTDIR)$(ATSNEWHOME)/"$$f" && \
	  echo "$$f"; \
	done

	# install specific files in the list as executables.
	for f in bin/*; do \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 755 -D "$$f" $(DESTDIR)$(ATSNEWHOME)/"$$f" && \
	  echo "$$f"; \
	done

	# install multiple copies of wrapper script, for each binary.
	for f in bin/*; do \
	  b=`basename "$$f"`; \
	  cd $(abs_top_srcdir) && \
	  $(INSTALL) -m 755 -D ats_env.sh $(DESTDIR)$(bindir)/"$$b" && \
	  echo install ats_env.sh to $(bindir)/"$$b"; \
	done

######

all:: \
  atsopt1 \
  bin/atscc \
  bin/atslib \
  libfiles libfiles_mt \
  bin/atspack \
  bin/atslex \
  ccomp/runtime/GCATS/gc.o \
  ccomp/runtime/GCATS/gc_mt.o \
  atsopt1_gc \
  contrib
	@echo "ATS/Anairiats has been built up successfully!"
	@echo "The value of ATSHOME for this build is \"$(ATSHOME)\"."
	@echo "The value of ATSHOMERELOC for this build is \"$(ATSHOMERELOC)\"."

###### w/o GC ######

atsopt1::
	$(MAKE) -C bootstrap1 -f ../Makefile_bootstrap BOOTSTRAP1=1 atsopt
	cp bootstrap1/atsopt $(ATSHOMEQ)/bin/atsopt

###### with GC ######

atsopt1_gc::
	$(MAKE) -C bootstrap1 -f ../Makefile_bootstrap BOOTSTRAP1=1 atsopt_gc
	cp bootstrap1/atsopt_gc $(ATSHOMEQ)/bin/atsopt

###### contrib libraries ######

contrib::
	cd contrib/parcomb; make all

ifeq ($(HAVE_LIBGLIB20),1)
	cd contrib/glib; make all
endif
ifeq ($(HAVE_LIBGTK20),1)
	cd contrib/cairo; make all
	cd contrib/pango; make all
	cd contrib/GTK; make all
endif
ifeq ($(HAVE_LIBSDL10),1)
	cd contrib/SDL; make all
endif

###### some toplevel commands ######

bin/atscc bin/atslib:
	cd utils/scripts; $(MAKE) atscc; cp atscc $(ATSHOMEQ)/bin
	cd utils/scripts; $(MAKE) atslib; cp atslib $(ATSHOMEQ)/bin
	cd utils/scripts; $(MAKE) clean

bin/atspack:
	cd utils/scripts; $(MAKE) atspack; cp atspack $(ATSHOMEQ)/bin

###### library ######

ATS_PROOFCHECK=
#
# ATS_PROOFCHECK=-D_ATS_PROOFCHECK # it should be turned on from time to time
#
# [CC -E] for preprocessing
#

ATSLIB=$(ATSHOMEQ)/bin/atslib

.libfiles_local: .libfiles ; $(CC) -E -P -x c -o $@ $<
libfiles: .libfiles_local
	$(ATSLIB) $(ATS_PROOFCHECK) -D_XOPEN_SOURCE -O2 --libats
	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_lex
	$(ATSLIB) $(ATS_PROOFCHECK) -O2 --libats_smlbas

lib32files: .libfiles_local
	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -D_XOPEN_SOURCE -O2 --libats
	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_lex
	$(ATSLIB) $(ATS_PROOFCHECK) -m32 -O2 --libats_smlbas

lib64files: .libfiles_local
	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -D_XOPEN_SOURCE -O2 --libats
	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_lex
	$(ATSLIB) $(ATS_PROOFCHECK) -m64 -O2 --libats_smlbas

.libfiles_mt_local: .libfiles_mt ; $(CC) -E -P -x c -o $@ $<
libfiles_mt: .libfiles_mt_local
	$(ATSLIB) $(ATS_PROOFCHECK) -D_ATS_MULTITHREAD -O2 --libats_mt

###### a lexer for ATS ######

bin/atslex:
	cd utils/atslex; $(MAKE) atslex; cp atslex $(ATSHOMEQ)/bin
	cd utils/atslex; $(MAKE) clean

###### GC runtime ######

ccomp/runtime/GCATS/gc.o:
	cd ccomp/runtime/GCATS; $(MAKE) gc.o; $(MAKE) clean

ccomp/runtime/GCATS/gc_mt.o:
	cd ccomp/runtime/GCATS; $(MAKE) gc_mt.o; $(MAKE) clean

######

clean::
	rm -f bootstrap1/*.o
	cd utils/scripts; $(MAKE) clean
	cd utils/atslex; $(MAKE) clean
	cd ccomp/runtime/GCATS; $(MAKE) clean

cleanall:: clean
	rm -f $(BUILT_CONFIG_FILES)
	rm -f .libfiles_local
	rm -f .libfiles_mt_local
	rm -f bin/atsopt bin/atscc bin/atslib bin/atslex bin/atspack
	rm -f ccomp/lib/libats.a
	rm -f ccomp/lib/libats_mt.a
	rm -f ccomp/lib/libats_lex.a
	rm -f ccomp/lib/libats_smlbas.a
	rm -f ccomp/lib/output/*
	rm -f ccomp/lib64/libats.a
	rm -f ccomp/lib64/libats_mt.a
	rm -f ccomp/lib64/libats_lex.a
	rm -f ccomp/lib64/libats_smlbas.a
	rm -f ccomp/lib64/output/*
	cd ccomp/runtime/GCATS; $(MAKE) cleanall
	rm -f contrib/glib/atsctrb_glib.o
	rm -f contrib/cairo/atsctrb_cairo.o
	rm -f contrib/pango/atsctrb_pango.o
	rm -f contrib/X11/atsctrb_X11.o
	rm -f contrib/GTK/atsctrb_GTK.o
	rm -f contrib/GL/atsctrb_GL.o
	rm -f contrib/SDL/atsctrb_SDL.o
	find . -name .svn -prune -o -name \*~ -exec rm \{} \;

######
#
# end of [Makefile_dist]
#
######

=== contrib/cblas/Makefile ===
#
# API for cblas in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Author: Shivkumar Chandrasekaran (shiv AT ece DOT ucsb DOT edu)
# Time: July, 2010
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc -Wall

LD=ld
LIBFLAGS=-L/usr/lib/atlas

######

all: atsctrb_cblas.o clean

######

atsctrb_cblas.o: \
  cblas_dats.o cblas_extra_dats.o
	$(LD) -r -o $@ $^

######

cblas_dats.o: DATS/cblas.dats
	$(ATSCC) $(LIBFLAGS) -o $@ -c DATS/cblas.dats

cblas_extra_dats.o: DATS/cblas_extra.dats
	$(ATSCC) $(LIBFLAGS) -o $@ -c DATS/cblas_extra.dats

######

clean::
	rm -f *_?ats.c *_?ats.o

cleanall: clean
	rm -f atsctrb_cblas.o

###### end of [Makefile] ######

=== contrib/glib/Makefile ===
#
# API for glib in ATS
#
# Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
# Time: February, 2010
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc -Wall

######

GCC=gcc

######

GLIBINC := -I"/usr/lib/glib-2.0/include"
GLIBINC += -I"/usr/lib64/glib-2.0/include"
INCLUDES= $(GLIBINC) -I"/usr/include/glib-2.0"

######

all:: glibconfig
all:: atsctrb_glib.o
all:: clean

######

glibconfig:: HATS/glibconfig
	$(GCC) $(INCLUDES) -E -P -o HATS/glibconfig.hats -x c HATS/glibconfig

######

atsctrb_glib.o: \
  glib_sats.o glib_dats.o
	ld -r -o $@ \
  glib_sats.o glib_dats.o

######

glib_sats.o: SATS/glib.sats
	$(ATSCC) $(INCLUDES) -o $@ -c SATS/glib.sats

glib_dats.o: DATS/glib.dats
	$(ATSCC) $(INCLUDES) -o $@ -c DATS/glib.dats

######

clean::
	rm -f glib_sats.c glib_sats.o
	rm -f glib_dats.c glib_dats.o

cleanall: clean
	rm -f atsctrb_glib.o

###### end of [Makefile] ######

=== ccomp/runtime/GCATS/Makefile ===
#########################################################################
##                                                                     ##
##                         Applied Type System                         ##
##                                                                     ##
##                              Hongwei Xi                             ##
##                                                                     ##
#########################################################################

##
## ATS/Anairiats - Unleashing the Power of Types!
##
## Copyright (C) 2002-2008 Hongwei Xi, Boston University
##
## All rights reserved
##
## ATS is  free software;  you can redistribute it and/or modify it under
## the  terms of the  GNU General Public License as published by the Free
## Software Foundation; either version 2.1, or (at your option) any later
## version.
## 
## ATS is distributed in the hope that it will be useful, but WITHOUT ANY
## WARRANTY; without  even  the  implied  warranty  of MERCHANTABILITY or
## FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
## for more details.
## 
## You  should  have  received  a  copy of the GNU General Public License
## along  with  ATS;  see the  file COPYING.  If not, please write to the
## Free Software Foundation,  51 Franklin Street, Fifth Floor, Boston, MA
## 02110-1301, USA.
##

## ###### ###### ##

## Author: Hongwei Xi (hwxi AT cs DOT bu DOT edu)
## Time: June 2008

## ###### ###### ##

GCC=gcc
ATSCC="${ATSHOME}"/bin/atscc

#CCFLAG=
CCFLAG=-O2
#ATSCCFLAG=-g
#ATSCCFLAG=-DGCATS_DEBUG
#ATSCCFLAG=-O2
ATSCCFLAG=-O2 -g

######

SOURCES := \
  gcats1_misc.dats \
  gcats1_freeitmlst.dats \
  gcats1_chunk.dats \
  gcats1_globalentry.dats \
  gcats1_marking.dats \
  gcats1_collecting.dats \
  gcats1_autops.dats \
  gcats1_manops.dats \
  gcats1_top.dats \

TARGETS := $(patsubst %.dats, %_dats.c, $(SOURCES))
TARGETS_mt := $(TARGETS) gcats1_multithread_dats.c
OBJECTS := $(patsubst %.dats, %_dats.o, $(SOURCES))
OBJECTS_mt := $(OBJECTS) gc_multithread_dats.o

######

#
# this generates a slower version:
#
# gc.o: gcats1_sats.o $(OBJECTS)
#	ld -r -o gc.o gcats1_sats.o $(OBJECTS)
#

gc.o: gc0_hats gcats1_sats.o gcats1_all_cats.o
	ld -r -o $@ gcats1_sats.o gcats1_all_cats.o

gc_mt.o: gc1_hats gcats1_sats.o gcats1_mt_all_cats.o
	ld -r -o $@ gcats1_sats.o gcats1_mt_all_cats.o

######

#
# mainly for the purpose of debugging
#
gcats1_main: gc0_hats gc.cats gcats1_sats.c gcats1_main.dats $(OBJECTS)
	$(ATSCC) $(CCFLAG) -o gcats1_main gcats1_main.dats gcats1_sats.c $(OBJECTS)

gcats1_main_mt: gc1_hats gc.cats gcats1_sats.c gcats1_main.dats $(OBJECTS_mt)
	$(ATSCC) $(CCFLAG) -pthread -o gcats1_main_mt gcats1_main.dats gcats1_sats.c $(OBJECTS_mt)

######

gc0_hats: ; gcc -E -P -D_ATS_MULTITHREAD0 -x c gcats1_master.hats -o gcats1.hats
gc1_hats: ; gcc -E -P -D_ATS_MULTITHREAD1 -x c gcats1_master.hats -o gcats1.hats

######

#
# this kind of whole compilation can probably take advantage of
# interprocedural optimization:
#
gcats1_all_cats.o: gcats1_sats.c $(TARGETS)
	$(ATSCC) $(CCFLAG) -o gcats1_all_cats.o -c -x c gcats1_all.cats

gcats1_mt_all_cats.o: gcats1_sats.c $(TARGETS_mt)
	$(ATSCC) $(CCFLAG) -o gcats1_mt_all_cats.o -c -x c gcats1_all.cats

######

gcats1_sats.c: gcats1.sats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1.sats
gcats1_sats.o: gcats1_sats.c; $(ATSCC) $(CCFLAG) -c gcats1_sats.c

######

gcats1_top_dats.c: gcats1_top.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_top.dats
gcats1_top_dats.o: gcats1_top_dats.c; $(ATSCC) $(CCFLAG) -c gcats1_top_dats.c

gcats1_misc_dats.c: gcats1_misc.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_misc.dats
gcats1_misc_dats.o: gcats1_misc_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_misc_dats.c

gcats1_freeitmlst_dats.c: gcats1_freeitmlst.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_freeitmlst.dats
gcats1_freeitmlst_dats.o: gcats1_freeitmlst_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_freeitmlst_dats.c

gcats1_chunk_dats.c: gcats1_chunk.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_chunk.dats
gcats1_chunk_dats.o: gcats1_chunk_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_chunk_dats.c

gcats1_globalentry_dats.c: gcats1_globalentry.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_globalentry.dats
gcats1_globalentry_dats.o: gcats1_globalentry_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_globalentry_dats.c

gcats1_multithread_dats.c: gcats1_multithread.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_multithread.dats
gcats1_multithread_dats.o: gcats1_multithread_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_multithread_dats.c

gcats1_marking_dats.c: gcats1_marking.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_marking.dats
gcats1_marking_dats.o: gcats1_marking_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_marking_dats.c

gcats1_collecting_dats.c: gcats1_collecting.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_collecting.dats
gcats1_collecting_dats.o: gcats1_collecting_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_collecting_dats.c

gcats1_autops_dats.c: gcats1_autops.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_autops.dats
gcats1_autops_dats.o: gcats1_autops_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_autops_dats.c

gcats1_manops_dats.c: gcats1_manops.dats
	$(ATSCC) $(ATSCCFLAG) -cc gcats1_manops.dats
gcats1_manops_dats.o: gcats1_manops_dats.c
	$(ATSCC) $(CCFLAG) -c gcats1_manops_dats.c

######

srclines::
	wc -l *.?ats

######

clean::
	rm -f gcats1.hats *_?ats.c *_?ats.o *~

cleanall:: clean; rm -f gc.o gc_mt.o

######
#
# end of [Makefile]
#
######

=== contrib/cblas/TEST/Makefile ===
#
#
# Makefile for some BLAS testing code 
#
#

######

ATSUSRQ="$(ATSHOME)"
ATSLIBQ="$(ATSHOME)"
ifeq ("$(ATSHOME)","")
ATSUSRQ="/usr"
ATSLIBQ="/usr/lib/ats-anairiats-0.2.3"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt
LIBFLAGS=-L/usr/lib/atlas -L/usr/lib64/atlas
ATSCTRB=$(ATSLIBQ)/contrib/cblas/atsctrb_cblas.o

######

.PHONY: all
all:: checkall
all:: cleanall

######

checkall::
cleanall:: clean

######

checkall:: test_cblas
test_cblas: test_cblas.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_cblas.dats $(ATSCTRB) -lcblas -lm \
     && ./test_cblas
cleanall:: ; $(RMF) test_cblas

######

checkall:: test_gemm1
test_gemm1: test_gemm1.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_gemm1.dats $(ATSCTRB) -lcblas -lm \
     && ./test_gemm1
cleanall:: ; $(RMF) test_gemm1

checkall:: test_gemm2
test_gemm2: test_gemm2.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_gemm2.dats $(ATSCTRB) -lcblas -lm \
     && ./test_gemm2
cleanall:: ; $(RMF) test_gemm2

######

checkall:: test_symm
test_symm: test_symm.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_symm.dats $(ATSCTRB) -lcblas -lm \
     && ./test_symm
cleanall:: ; $(RMF) test_symm

######

checkall:: test_lu
test_lu: test_lu.dats
	$(ATSCC) $(LIBFLAGS) -O2 -o $@ test_lu.dats $(ATSCTRB) -lcblas -lm \
     && ./test_lu
cleanall:: ; $(RMF) test_lu

######

html:: ; $(ATSOPT) --posmark_html -d test_cblas.dats > test_cblas_dats.html
cleanall:: ; $(RMF) *_?ats.html

######

RMF = rm -f

######

clean::
	$(RMF) *~
	$(RMF) *_?ats.c *_?ats.o

###### end of [Makefile] ######

=== contrib/clapack/TEST/Makefile ===
#
#
# Makefile for some BLAS testing code 
#
#

######

ATSUSRQ="$(ATSHOME)"
ATSLIBQ="$(ATSHOME)"
ifeq ("$(ATSHOME)","")
ATSUSRQ="/usr"
ATSLIBQ="/usr/lib/ats-anairiats-0.2.3"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt

LIBFLAGS=-L/usr/lib/atlas -L/usr/lib64/atlas
ATSCTRB=\
  $(ATSLIBQ)/contrib/cblas/atsctrb_cblas.o \
  $(ATSLIBQ)/contrib/clapack/atsctrb_clapack.o \

######

.PHONY: all

# ######

all:: checkall
all:: cleanall

######

checkall::
cleanall:: clean

######

checkall:: test_clapack
test_clapack: test_clapack.dats
	$(ATSCC) $(LIBFLAGS) -O3 -o $@ $< $(ATSCTRB) -llapack -lcblas \
      && ./test_clapack
cleanall:: ; $(RMF) test_clapack

######

html:: ; $(ATSOPT) --posmark_html -d test_clapack.dats > test_clapack_dats.html
cleanall:: ; $(RMF) test_clapack_dats.html

######

RMF = rm -f

######

clean:
	$(RMF) *~
	$(RMF) *_?ats.c *_?ats.o

###### end of [Makefile] ######

=== doc/EXAMPLE/TEST/Makefile ===
#
#
# (kind of) unit testing for ATS library code
#
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt

######

.PHONY: all
all:: checkall
all:: cleanall

######

checkall::
cleanall:: clean

######

checkall:: prelude_array
prelude_array: prelude_array.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_array
cleanall:: ; $(RMF) prelude_array

checkall:: prelude_array0
prelude_array0: prelude_array0.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_array0
cleanall:: ; $(RMF) prelude_array0

checkall:: prelude_bool
prelude_bool: prelude_bool.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_bool
cleanall:: ; $(RMF) prelude_bool

checkall:: prelude_char
prelude_char: prelude_char.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_char
cleanall:: ; $(RMF) prelude_char

checkall:: prelude_float
prelude_float: prelude_float.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_float
cleanall:: ; $(RMF) prelude_float

checkall:: prelude_lazy_vt
prelude_lazy_vt: prelude_lazy_vt.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_lazy_vt
cleanall:: ; $(RMF) prelude_lazy_vt

checkall:: prelude_list
prelude_list: prelude_list.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_list
cleanall:: ; $(RMF) prelude_list

checkall:: prelude_list_vt
prelude_list_vt: prelude_list_vt.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_list_vt
cleanall:: ; $(RMF) prelude_list_vt

checkall:: prelude_matrix
prelude_matrix: prelude_matrix.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_matrix
cleanall:: ; $(RMF) prelude_matrix

checkall:: prelude_matrix0
prelude_matrix0: prelude_matrix0.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_matrix0
cleanall:: ; $(RMF) prelude_matrix0

checkall:: prelude_string
prelude_string: prelude_string.dats
	$(ATSCC) -O2 -o $@ $< && ./prelude_string
cleanall:: ; $(RMF) prelude_string

######

checkall:: libc_complex
libc_complex: libc_complex.dats
	$(ATSCC) -O2 -o $@ $< -lm && ./libc_complex
cleanall:: ; $(RMF) libc_complex

######

checkall:: libc_dirent
libc_dirent: libc_dirent.dats
	$(ATSCC) -O2 -o $@ $< && ./libc_dirent "."
cleanall:: ; $(RMF) libc_dirent

checkall:: libc_dlfcn
libc_dlfcn: libc_dlfcn.dats
	$(ATSCC) -rdynamic -O2 -o $@ $< -ldl && ./libc_dlfcn "."
cleanall:: ; $(RMF) libc_dlfcn

######

checkall:: libc_gmp
libc_gmp: libc_gmp.dats
	$(ATSCC) -D_GNU_SOURCE -O2 -o $@ $< -lats -lgmp && ./libc_gmp
cleanall:: ; $(RMF) libc_gmp

######

checkall:: libc_printf
libc_printf: libc_printf.dats
	$(ATSCC) -o $@ $< && ./libc_printf
cleanall:: ; $(RMF) libc_printf

######

checkall:: libc_pwd
libc_pwd: libc_pwd.dats
	$(ATSCC) -O2 -o $@ $< && ./libc_pwd
cleanall:: ; $(RMF) libc_pwd

######

checkall:: libc_random
libc_random: libc_random.dats
	$(ATSCC) -O2 -o $@ $< && ./libc_random
cleanall:: ; $(RMF) libc_random

######

checkall:: libc_sched
libc_sched: libc_sched.dats
	$(ATSCC) -D_GNU_SOURCE -O2 -o $@ $< && ./libc_sched
cleanall:: ; $(RMF) libc_sched

######

checkall:: libc_stdio
libc_stdio: libc_stdio.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_stdio
cleanall:: ; $(RMF) libc_stdio

checkall:: libc_stdlib
libc_stdlib: libc_stdlib.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_stdlib
cleanall:: ; $(RMF) libc_stdlib

######

checkall:: libc_time
libc_time: libc_time.dats
	$(ATSCC) -D_XOPEN_SOURCE -O2 -o $@ $< && ./libc_time
cleanall:: ; $(RMF) libc_time

######

checkall:: libc_unistd
libc_unistd: libc_unistd.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_unistd
cleanall:: ; $(RMF) libc_unistd

######


checkall:: libc_sys_utsname
libc_sys_utsname: libc_sys_utsname.dats ; $(ATSCC) -O2 -o $@ $< && ./libc_sys_utsname
cleanall:: ; $(RMF) libc_sys_utsname

######


checkall:: libats_funarray_braun
libats_funarray_braun: libats_funarray_braun.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< \
     && ./libats_funarray_braun 0 1 2 3 4 5 6 7 8 9
cleanall:: ; $(RMF) libats_funarray_braun

######

checkall:: libats_fundeque_fingertree
libats_fundeque_fingertree: libats_fundeque_fingertree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_fundeque_fingertree 10
cleanall:: ; $(RMF) libats_fundeque_fingertree

######

checkall:: libats_funheap_braun
libats_funheap_braun: libats_funheap_braun.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funheap_braun

######

checkall:: libats_funmap_avltree
libats_funmap_avltree: libats_funmap_avltree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funmap_avltree


######

checkall:: libats_funralist_nested
libats_funralist_nested: libats_funralist_nested.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./$@ 100000
cleanall:: ; $(RMF) libats_funralist_nested

######

checkall:: libats_genarrays
libats_genarrays: libats_genarrays.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_genarrays
cleanall:: ; $(RMF) libats_genarrays

######

checkall:: libats_hashtable_chain
libats_hashtable_chain: libats_hashtable_chain.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_hashtable_chain 100000
cleanall:: ; $(RMF) libats_hashtable_chain

checkall:: libats_hashtable_linprb
libats_hashtable_linprb: libats_hashtable_linprb.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_hashtable_linprb 100000
cleanall:: ; $(RMF) libats_hashtable_linprb

######

checkall:: libats_intinf
libats_intinf: libats_intinf.dats
	$(ATSCC) -O2 -o $@ $< -lats -lgmp && ./libats_intinf 10
cleanall:: ; $(RMF) libats_intinf

checkall:: libats_iterint
libats_iterint: libats_iterint.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_iterint
cleanall:: ; $(RMF) libats_iterint

######

checkall:: libats_linbitvec
libats_linbitvec: libats_linbitvec.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_linbitvec
cleanall:: ; $(RMF) libats_linbitvec

######

checkall:: libats_linmap_avltree
libats_linmap_avltree: libats_linmap_avltree.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linmap_avltree 100000
cleanall:: ; $(RMF) libats_linmap_avltree

######

checkall:: libats_linqueue_arr
libats_linqueue_arr: libats_linqueue_arr.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linqueue_arr 1000000
cleanall:: ; $(RMF) libats_linqueue_arr

######

checkall:: libats_linqueue_lst
libats_linqueue_lst: libats_linqueue_lst.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linqueue_lst 1000000
cleanall:: ; $(RMF) libats_linqueue_lst

######

checkall:: libats_linstack_arr
libats_linstack_arr: libats_linstack_arr.dats
	$(ATSCC) -D_ATS_GCATS -O2 -o $@ $< && ./libats_linstack_arr 1000000
cleanall:: ; $(RMF) libats_linstack_arr

######

checkall:: libats_parworkshop
libats_parworkshop: libats_parworkshop.dats
	$(ATSCC) -D_ATS_MULTITHREAD -O2 -o $@ $< -lpthread -lats_mt && ./libats_parworkshop
cleanall:: ; $(RMF) libats_parworkshop

######

checkall:: libats_rarray
libats_rarray: libats_rarray.dats
	$(ATSCC) -O2 -o $@ $< && ./libats_rarray
cleanall:: ; $(RMF) libats_rarray

######

checkall:: libats_regexp
libats_regexp: libats_regexp.dats
	$(ATSCC) -O2 -o $@ $< -lats -lpcre && ./libats_regexp
cleanall:: ; $(RMF) libats_regexp

######

checkall:: libats_vector
libats_vector: libats_vector.dats
	$(ATSCC) -O2 -o libats_vector libats_vector.dats && ./libats_vector
cleanall:: ; $(RMF) libats_vector

######

checkall:: libats_ngc_slist
libats_ngc_slist: libats_ngc_slist.dats
	$(ATSCC) -O2 -o $@ $< && ./$@
cleanall:: ; $(RMF) libats_ngc_slist

######

checkall:: libats_smlbas_array
libats_smlbas_array: libats_smlbas_array.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_array

checkall:: libats_smlbas_array2
libats_smlbas_array2: libats_smlbas_array2.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_array2

checkall:: libats_smlbas_char
libats_smlbas_char: libats_smlbas_char.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_char

checkall:: libats_smlbas_list
libats_smlbas_list: libats_smlbas_list.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_list

checkall:: libats_smlbas_string
libats_smlbas_string: libats_smlbas_string.dats
	$(ATSCC) -O2 -o $@ $< -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_string

checkall:: libats_smlbas_time
libats_smlbas_time: libats_smlbas_time.dats
	$(ATSCC) -O2 -o $@ $< -lm -lats_smlbas && ./$@
cleanall:: ; $(RMF) libats_smlbas_time

######

RMF=rm -f

######

clean:
	$(RMF) *~
	$(RMF) *_?ats.c *_?ats.o

###### end of [Makefile] ######

=== doc/EXAMPLE/cairo/Makefile ===
#
#
# Some Examples in ATS involving GTK+ programming
#
#

######

ATSUSRQ="$(ATSHOME)"
ifeq ($(ATSUSRQ),"")
ATSUSRQ="/usr"
endif

######

ATSCC=$(ATSUSRQ)/bin/atscc
ATSOPT=$(ATSUSRQ)/bin/atsopt

######

XRCFLAGS=`pkg-config cairo --cflags`
GTKCLFLAGS=`pkg-config gtk+-2.0 --cflags --libs`

######

.PHONY: all
all:: checkall
all:: cleanall

######

checkall::
cleanall:: clean

######

checkall:: blurring
cleanall:: ; $(RMF) blurring
blurring: blurring.dats blur_image_surface.o
	$(ATSCC) -o $@ blurring.dats blur_image_surface.o $(GTKCLFLAGS) -lm
blur_image_surface.o: blur_image_surface.dats
	$(ATSCC) -c -o $@ blur_image_surface.dats $(XRCFLAGS)

######

checkall:: clip-all
cleanall:: ; $(RMF) clip-all
clip-all: clip-all.dats
	$(ATSCC) -o $@ clip-all.dats $(GTKCLFLAGS)

######

checkall:: push-group
cleanall:: ; $(RMF) push-group
push-group: push-group.dats
	$(ATSCC) -g -o $@ push-group.dats $(GTKCLFLAGS)

######

checkall:: stroke-image
cleanall:: ; $(RMF) stroke-image
stroke-image: stroke-image.dats
	$(ATSCC) -o $@ stroke-image.dats $(GTKCLFLAGS)

######

checkall:: testcairo
cleanall:: ; $(RMF) testcairo
testcairo: testcairo.dats
	$(ATSCC) -o $@ testcairo.dats $(GTKCLFLAGS) -lm

######

checkall:: text-rotate
cleanall:: ; $(RMF) text-rotate
text-rotate: text-rotate.dats
	$(ATSCC) -o $@ text-rotate.dats $(GTKCLFLAGS) -lm

checkall:: text-transform
cleanall:: ; $(RMF) text-transform
text-transform: text-transform.dats
	$(ATSCC) -o $@ text-transform.dats $(GTKCLFLAGS) -lm

######

RMF = rm -f

######

clean::
	$(RMF) *~
	$(RMF) *_?ats.c *_?ats.o

###### end of [Makefile] ######

=== debian/changelog ===
ats-lang-anairiats (0.2.4-1) unstable; urgency=low

  * New upstream release

 -- Matthew Danish <mrd@debian.org>  Mon, 25 Apr 2011 12:53:22 -0400

=== debian/control ===
Source: ats-lang-anairiats
Section: devel
Priority: optional
Maintainer: Matthew Danish <mrd@debian.org>
Build-Depends: debhelper (>= 7), libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, libgl1-mesa-dev | libgl-dev, libglu1-mesa-dev | libglu-dev, libblas-dev, liblapack-dev
Standards-Version: 3.9.1
Homepage: http://www.ats-lang.org

Package: ats-lang-anairiats
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libgmp3-dev, libpcre3-dev, libsdl1.2-dev, libgtk2.0-dev, libcairo2-dev
Suggests: ats-lang-anairiats-examples, ats-lang-anairiats-doc
Description: ATS language compiler named Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains the compiler atsopt, the frontend atscc, and 
 the lexer atslex.

Package: ats-lang-anairiats-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: ats-lang-anairiats
Description: Examples for the ATS compiler Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains some examples of the language.

Package: ats-lang-anairiats-doc
Architecture: all
Depends: ${misc:Depends}
Recommends: ats-lang-anairiats
Section: doc
Description: Documentation for the ATS compiler Anairiats
 ATS is a programming language with a highly expressive type system
 rooted in the framework Applied Type System. In particular, both
 dependent types and linear types are available in ATS. The current
 implementation of ATS (ATS/Anairiats) is written in ATS itself. It
 can be as efficient as C/C++ and supports a variety of programming
 paradigms.
 .
 In addition, ATS contains a component ATS/LF that supports a form of
 (interactive) theorem proving, where proofs are constructed as total
 functions. With this component, ATS advocates a programming style
 that combines programming with theorem proving. Furthermore, this
 component may be used as a logical framework to encode various
 deduction systems and their (meta-)properties.
 .
 This package contains some documentation for the language.
